package main

import (
	"github.com/hyperledger/fabric/core/chaincode/shim"
	"gitlab.smartblocklab.com/smartcontracts/common/chaincode"
	"gitlab.smartblocklab.com/smartcontracts/common/invoke"
	"gitlab.smartblocklab.com/smartcontracts/offersessionCC/function"
)

func NewChaincode() shim.Chaincode {

	// invoke

	chaincode.ChaincodeVar.Actions[invoke.AddOfferFunction] = function.AddOffer
	chaincode.ChaincodeVar.Actions[invoke.AddSessionFunction] = function.AddSession

	// query

	chaincode.ChaincodeVar.Actions[invoke.GetOffersFunction] = function.GetOffers
	chaincode.ChaincodeVar.Actions[invoke.GetOfferRecordsFunction] = function.GetOfferRecords

	chaincode.ChaincodeVar.Actions[invoke.GetCurrentSessionFunction] = function.GetCurrentSession
	chaincode.ChaincodeVar.Actions[invoke.GetSessionsFunction] = function.GetSessions
	chaincode.ChaincodeVar.Actions[invoke.GetOffersByCurrentSessionFunction] = function.GetOffersByCurrentSession
	chaincode.ChaincodeVar.Actions[invoke.GetOffersBySessionFunction] = function.GetOffersBySession

	chaincode.ChaincodeVar.Actions[invoke.ClearLedger] = function.ClearLedger
	return &chaincode.ChaincodeVar
}
