package mngr

import (
	"gitlab.smartblocklab.com/smartcontracts/common/model/offerCC"
	"gitlab.smartblocklab.com/smartcontracts/common/model/transactionCC"
	"gitlab.smartblocklab.com/smartcontracts/common/chaincode"
	"errors"
)

func (this OfferSessionManagerImpl) checkLockAmountByOperationIDAndUserID(offerRecord *offerCC.OfferRecord) error {
	if offerRecord == nil {
		return errors.New("offer can't be nil")
	}

	findLockAmountByOperationIDAndUserIdArg := transactionCC.FindLockAmountByOperationIdAndUserIdAndCurrencyTypeArg{}
	findLockAmountByOperationIDAndUserIdArg.OperationID = offerRecord.OperationID
	findLockAmountByOperationIDAndUserIdArg.UserAccountInfo = offerRecord.UserAccountInfo
	findLockAmountByOperationIDAndUserIdArg.Amount =  offerRecord.Amount
	findLockAmountResult, err := this.TransactionCC.FindLockAmountByOperationIdAndUserIdAndCurrencyType(findLockAmountByOperationIDAndUserIdArg)
	if err != nil {
		return err
	}

	foundAmountNumber, err := findLockAmountResult.Amount.Number()
	if err != nil {
		return err
	}

	offerRequestAmountNumber, err := offerRecord.Amount.Number()
	isEquals, err := foundAmountNumber.Equals(offerRequestAmountNumber)
	if err != nil {
		return err
	}
	if !isEquals {
		return chaincode.GlobalLogger.Errorf("locked amount %s for user %s dose not equals expected offerRequest amount %s",
			foundAmountNumber.RoundBankString(), findLockAmountByOperationIDAndUserIdArg.UserAccountInfo.String(), offerRequestAmountNumber.RoundBankString())
	}

	return nil
}
