package mngr

import (
	"gitlab.smartblocklab.com/smartcontracts/common/model/offerCC"
	"gitlab.smartblocklab.com/smartcontracts/common/model/requests"
)

func (this OfferSessionManagerImpl) GetOfferRecords(userID *requests.Id) (*offerCC.OfferRecords, error) {
	result := &offerCC.OfferRecords{
		OfferRecords: make([]*offerCC.OfferRecord, 0),
	}

	validObjects, err := this.GetObjectListByKeysWithFilter(&offerCC.OfferRecord{}, []string{userID.Id})
	if err != nil {
		return nil, err
	}

	for _, voOfferRequest := range validObjects {
		offerRequest, err := offerCC.Cast(voOfferRequest)
		if err != nil {
			return nil, err
		}

		result.OfferRecords = append(result.OfferRecords, offerRequest)
	}

	return result, nil
}
