package chaincode

func ClearLedger(objectType string, manager IManager) (int, error) {
	GlobalLogger.Info("ClearLedger")
	it, err := manager.GetStateByPartialCompositeKey(objectType, []string{})
	if err != nil {
		return 0, err
	}
	if it == nil {
		return 0, nil
	}

	counter := 0
	defer it.Close() // Do not forget to close iterator once get used
	for it.HasNext() {
		kv, err := it.Next()
		if err != nil {
			return 0, err
		}

		err = manager.DelState(kv.Key)
		if err != nil {
			return 0, err
		}
		counter++;
	}
	return counter, nil
}

type ClearLedgerResult struct {
	Count int;
}
