package ioffersession

import (
	"gitlab.smartblocklab.com/smartcontracts/common/model/offerCC"
	"gitlab.smartblocklab.com/smartcontracts/common/model/requests"
	"gitlab.smartblocklab.com/smartcontracts/common/model/keyValueCC"
)

type IOfferSessionManager interface {

	// пользователи

	// invoke
	AddOffer(outOfferRequest *offerCC.OfferRecord, inOfferRequest *offerCC.OfferRecord, operationID *requests.Id) (*offerCC.OfferRecords, error)

	// query
	GetOfferRecords(userId *requests.Id) (*offerCC.OfferRecords, error)
	GetOffers(userId *requests.Id) (*offerCC.Offers, error)

	// сессии

	// invoke
	AddSession(keyValue *keyValueCC.KeyValue) (*keyValueCC.KeyValue, error)

	// query
	GetCurrentSession() (*keyValueCC.KeyValue, error)
	GetSessions() (*keyValueCC.KeyValueArray, error)

	// связь заявок и сессии

	// query
	GetOffersBySession(sessionID *requests.Id) (*keyValueCC.KeyValue, error)
	GetOffersByCurrentSession() (*keyValueCC.KeyValue, error)
}
