package itransaction

import (
	"gitlab.smartblocklab.com/smartcontracts/common/model/transactionCC"
	"gitlab.smartblocklab.com/smartcontracts/common/model/requests"
)

type ITransactionManager interface {

	// invoke

	LockFundsOnAccount(txnArgs *transactionCC.TxnFundsLockInput) (*transactionCC.TransactionList, error)
	LockOutFundsOnAccount(txnArgs *transactionCC.OutTxnFundsLockInput) (*transactionCC.TransactionList, error)
	TransferFunds(transfer *transactionCC.Transfer) (*transactionCC.TransactionList, error)
	UnlockFundsOnAccount(transfer *transactionCC.Transfer) (*transactionCC.TransactionList, error)

	LoadCryptocurrency(systemUserID string) (*transactionCC.LoadCryptocurrencyResultList, error)

	//LockTransferToMarket(txnArgs *transactionCC.OutTxnFundsLockInput) error
	//LoadMarketFounds(operationID *requests.Id) (*transactionCC.LoadCryptocurrencyResultList, error)
	//WithdrawalMarketFounds(findLockAmountByOperationIDAndUserIdArg transactionCC.FindLockAmountByOperationIdAndUserIdAndCurrencyTypeArg) error

	// query

	CheckExistsTransactionByList(syncRequest *transactionCC.SyncRequest) (*transactionCC.CheckExistsResult, error)
	GetTransactions(userId *requests.Id) (*transactionCC.TransactionList, error)
	FindLockAmountByOperationIdAndUserIdAndCurrencyType(findLockAmountByOperationIDAndUserIdArg transactionCC.FindLockAmountByOperationIdAndUserIdAndCurrencyTypeArg) (*transactionCC.FindLockAmountResult, error)
	AccountCurrencyBalance(accountCurrencyBalanceArg transactionCC.AccountCurrencyBalanceArg) (*transactionCC.AccountBalance, error)
}
