package offerCC

import (
	"github.com/pkg/errors"
	"encoding/json"
)

// OfferRequest запрос на создание out -> in offerRecord
type OfferRequest struct {
	OutUserInfo       *OfferRequestInfo `json:"out_info,omitempty"`
	InUserInfo        *OfferRequestInfo `json:"in_info,omitempty"`
	OfferRecordStatus OfferRecordStatus `json:"offer_record_status,omitempty"`
	ReplayedKey       string            `json:"replayed_key"`
}

func (this OfferRequest) Validate() error {
	if this.OutUserInfo == nil {
		return errors.New("OutUserInfo is empty")
	}

	if len(this.OfferRecordStatus) == 0 {
		return errors.New("RequestStatus is empty")
	}

	return nil
}

func Unmarshal_OfferRequest(data []byte) (*OfferRequest, error) {
	var obj OfferRequest
	err := json.Unmarshal(data, &obj)
	return &obj, err;
}
