package requests

import (
	"encoding/json"
	"errors"
	"gitlab.smartblocklab.com/smartcontracts/common/logging"
)

type Id struct {
	Id string `json:"id,omitempty"`
}

type ArrayId struct {
	ArrayId []Id `json:"array_id,omitempty"`
}

type ArrayKeysWithFilter struct {
	ArrayKeysWithFilter []KeysWithFilter `json:"array_keys_with_filter,omitempty"`
}

type KeysWithFilter struct {
	Keys       []string `json:"keys,omitempty"`
	FilterKeys []string `json:"filter_keys,omitempty"`
}

func UnmarshalKeysWithFilter(data []byte) (*KeysWithFilter, error) {
	if data == nil {
		return nil, logging.Get().Error("can't Unmarshal nil data")
	}

	var obj KeysWithFilter
	err := json.Unmarshal(data, &obj)
	return &obj, err;
}

func UnmarshalArrayId(data []byte) (*ArrayId, error) {
	if data == nil {
		return nil, logging.Get().Error("can't Unmarshal nil data")
	}

	var obj ArrayId
	err := json.Unmarshal(data, &obj)
	return &obj, err;
}

func (this Id) Validate() error {
	if len(this.Id) == 0 {
		return errors.New("Id is empty")
	}

	return nil
}

func Unmarshal(data []byte) (*Id, error) {
	if data == nil {
		return nil, logging.Get().Error("can't Unmarshal nil data")
	}

	var obj Id
	err := json.Unmarshal(data, &obj)
	return &obj, err;
}

func (this Id) Marshal() ([]byte, error) {
	return json.Marshal(this);
}
